import React, { Fragment, useCallback, useEffect, useRef, useState } from 'react';
import { useAccess, useParams } from '@umijs/max';
import { Button, FormInstance, message, Modal } from 'antd';
import { ActionType, ProColumns, ProTable } from '@ant-design/pro-components';
import { DeleteOutlined, FormOutlined, PlusOutlined } from '@ant-design/icons';
import {
  addCmsLinePlatForm,
  deleteCmsLinePlatForm,
  getCmsLineListPlatForm,
} from '@/services/area/upline';
import UpStationEdit from '@/pages/Area/Subway/UpLine/edit';

const handleRemoveOne = async (selectedRow: API.AreaSubWay.LinePoint) => {
  const hide = message.loading('正在删除');
  if (!selectedRow) return true;
  try {
    const resp = await deleteCmsLinePlatForm(selectedRow.stationId);
    hide();
    if (resp.code === 200) {
      message.success('删除成功，即将刷新');
    } else {
      message.error(resp.msg);
    }
    return true;
  } catch (error) {
    hide();
    message.error('删除失败，请重试');
    return false;
  }
};

function ManagementList() {
  const access = useAccess();

  const formTableRef = useRef<FormInstance>();
  const actionRef = useRef<ActionType>();
  const [lineId, setLineId] = useState<string>();
  const [currentRow, setCurrentRow] = useState<API.AreaPlatForm.LinePoint>();
  const [modalVisible, setModalVisible] = useState<boolean>(false);
  const [page, setPage] = useState<API.AreaPlatForm.LineParams>({});
  const params = useParams();
  const id = params.id || '0';
  useEffect(() => {
    if (lineId !== id) {
      setLineId(id);
    }
  }, [lineId, params]);
  const getStationInfo = useCallback(async () => {
    // const resData = await getCmsLineSubWay()
  }, []);

  const columns: ProColumns<API.AreaSubWay.LinePoint>[] = [
    {
      title: '站点名称',
      dataIndex: 'stationName',
      align: 'center',
      valueType: 'text',
    },
    {
      title: '排序',
      dataIndex: 'stationOrder',
      align: 'center',
      valueType: 'text',
    },
    {
      title: '操作',
      hideInSearch: true,
      align: 'center',
      width: 300,
      render: (_, record) => [
        <Button
          type="link"
          size="small"
          key="edit"
          icon={<FormOutlined />}
          hidden={!access.hasPerms('area:business:List.update')}
          onClick={() => {
            setModalVisible(true);
            setCurrentRow(record);
          }}
        >
          编辑
        </Button>,
        <Button
          type="link"
          size="small"
          danger
          key="batchRemove"
          icon={<DeleteOutlined />}
          hidden={!access.hasPerms('area:subway:List')}
          onClick={async () => {
            Modal.confirm({
              title: '删除',
              content: '确定删除该项吗？',
              okText: '确认',
              cancelText: '取消',
              onOk: async () => {
                const success = await handleRemoveOne(record);
                if (success) {
                  if (actionRef.current) {
                    actionRef.current.reload();
                  }
                }
              },
            });
          }}
        >
          删除
        </Button>,
      ],
    },
  ];
  return (
    <Fragment>
      <div style={{ width: '100%', float: 'right' }}>
        <ProTable<API.AreaPlatForm.Line>
          // params 是需要自带的参数
          // 这个参数优先级更高，会覆盖查询表单的参数
          actionRef={actionRef}
          formRef={formTableRef}
          columns={columns}
          headerTitle="信息"
          rowKey="stationId"
          key="stationId"
          request={(params) => {
            return getCmsLineListPlatForm({
              lineId,
              ...params,
            } as API.AreaPlatForm.LineParams).then((res) => {
              setPage(params as API.AreaPlatForm.LineParams);
              const result = {
                data: res.rows,
                total: res.total,
                success: true,
              };
              return result;
            });
          }}
          toolBarRender={() => [
            <Button
              type="primary"
              key="add"
              hidden={!access.hasPerms('manage:List:add')}
              onClick={async () => {
                setCurrentRow(undefined);
                setModalVisible(true);
              }}
            >
              <PlusOutlined /> 新建
            </Button>,
          ]}
        />
      </div>
      <UpStationEdit
        open={modalVisible}
        onCancel={() => {
          setModalVisible(false);
          setCurrentRow(undefined);
        }}
        onSubmit={async (values) => {
          // values.lineId =
          //   values.lineName =
          const resData = await addCmsLinePlatForm(values);
          if (resData.code === 200) {
            setModalVisible(false);
            setCurrentRow(undefined);
            message.success('添加成功');
            if (actionRef.current) {
              actionRef.current.reload();
            }
          }
        }}
        values={currentRow}
      ></UpStationEdit>
    </Fragment>
  );
}

export default ManagementList;
